export declare abstract class Storage {
    storageKey: string;
    storage: Record<string, any>;
    static get isAvailable(): boolean;
    constructor(storageKey: string);
    get<T>(key: string): T | void;
    set<T>(key: string, value: T): void;
    remove(key: string): void;
    clear(): void;
    refresh(): void;
    protected abstract clearStorage(): void;
    protected abstract readStorage(): Record<string, any>;
    protected abstract writeStorage(): void;
}
