'use strict';

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); Object.defineProperty(subClass, "prototype", { writable: false }); if (superClass) _setPrototypeOf(subClass, superClass); }
function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }
function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } else if (call !== void 0) { throw new TypeError("Derived constructors may only return object or undefined"); } return _assertThisInitialized(self); }
function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf.bind() : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }
function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }
function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }
function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }
function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
var Storage = /*#__PURE__*/function () {
  function Storage(storageKey) {
    _classCallCheck(this, Storage);
    _defineProperty(this, "storageKey", void 0);
    _defineProperty(this, "storage", void 0);
    this.storageKey = storageKey;
    this.storage = this.readStorage();
  }
  _createClass(Storage, [{
    key: "get",
    value: function get(key) {
      return this.storage[key];
    }
  }, {
    key: "set",
    value: function set(key, value) {
      if (this.storage[key] === value) return;
      this.storage[key] = value;
      this.writeStorage();
    }
  }, {
    key: "remove",
    value: function remove(key) {
      delete this.storage[key];
      this.writeStorage();
    }
  }, {
    key: "clear",
    value: function clear() {
      this.storage = {};
      this.clearStorage();
    }
  }, {
    key: "refresh",
    value: function refresh() {
      this.storage = this.readStorage();
    }
  }], [{
    key: "isAvailable",
    get: function get() {
      return false;
    }
  }]);
  return Storage;
}();
function serialize(data) {
  return JSON.stringify(data);
}
function deserialize(json) {
  if (json == null) return {};
  try {
    return JSON.parse(json);
  } catch (_unused) {
    return {};
  }
}
var DEFAULT_OPTIONS = {
  sameSite: "strict",
  secure: true
};
var CookieStorage = /*#__PURE__*/function (_Storage) {
  _inherits(CookieStorage, _Storage);
  var _super = _createSuper(CookieStorage);
  function CookieStorage(storageKey) {
    var _this;
    var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
    _classCallCheck(this, CookieStorage);
    _this = _super.call(this, storageKey);
    _defineProperty(_assertThisInitialized(_this), "options", void 0);
    _this.options = _objectSpread(_objectSpread({}, DEFAULT_OPTIONS), options);
    return _this;
  }
  _createClass(CookieStorage, [{
    key: "clearStorage",
    value: function clearStorage() {
      window.document.cookie = "".concat(this.storageKey, "=; Expires=").concat(new Date().toUTCString());
    }
  }, {
    key: "readStorage",
    value: function readStorage() {
      var cookies = window.document.cookie.split(/;\s?/).reduce(function (result, cookie) {
        var separatorIndex = cookie.search("=");
        var key = cookie.slice(0, separatorIndex);
        var value = cookie.slice(separatorIndex + 1);
        result[key] = decodeURIComponent(value);
        return result;
      }, {});
      return deserialize(cookies[this.storageKey]);
    }
  }, {
    key: "writeStorage",
    value: function writeStorage() {
      var value = encodeURIComponent(serialize(this.storage));
      var expiryDate = new Date(2200, 0, 1);
      var cookie = ["".concat(this.storageKey, "=").concat(value), "SameSite=".concat(this.options.sameSite), "Expires=".concat(expiryDate.toUTCString())];
      if (this.options.secure) cookie.push("secure");
      document.cookie = cookie.join("; ");
    }
  }], [{
    key: "isAvailable",
    get: function get() {
      if (typeof window === 'undefined') return false;
      if (window.navigator == null) return false;
      return window.navigator.cookieEnabled;
    }
  }]);
  return CookieStorage;
}(Storage);
var TEST_KEY$1 = "__LOCALSTORAGE_TEST_KEY__";
var TEST_VALUE$1 = "__LOCALSTORAGE_TEST_VALUE__";
var LocalStorage = /*#__PURE__*/function (_Storage2) {
  _inherits(LocalStorage, _Storage2);
  var _super2 = _createSuper(LocalStorage);
  function LocalStorage() {
    _classCallCheck(this, LocalStorage);
    return _super2.apply(this, arguments);
  }
  _createClass(LocalStorage, [{
    key: "clearStorage",
    value: function clearStorage() {
      localStorage.removeItem(this.storageKey);
    }
  }, {
    key: "readStorage",
    value: function readStorage() {
      return deserialize(localStorage.getItem(this.storageKey));
    }
  }, {
    key: "writeStorage",
    value: function writeStorage() {
      localStorage.setItem(this.storageKey, serialize(this.storage));
    }
  }], [{
    key: "isAvailable",
    get: function get() {
      try {
        if (_typeof(window.localStorage) === "object") {
          window.localStorage.setItem(TEST_KEY$1, TEST_VALUE$1);
          if (window.localStorage.getItem(TEST_KEY$1) === TEST_VALUE$1) {
            window.localStorage.removeItem(TEST_KEY$1);
            return true;
          }
        }
      } catch (_unused2) {}
      return false;
    }
  }]);
  return LocalStorage;
}(Storage);
var MemoryStorage = /*#__PURE__*/function (_Storage3) {
  _inherits(MemoryStorage, _Storage3);
  var _super3 = _createSuper(MemoryStorage);
  function MemoryStorage() {
    _classCallCheck(this, MemoryStorage);
    return _super3.apply(this, arguments);
  }
  _createClass(MemoryStorage, [{
    key: "clearStorage",
    value: function clearStorage() {}
  }, {
    key: "readStorage",
    value: function readStorage() {
      var _this$storage;
      return (_this$storage = this.storage) !== null && _this$storage !== void 0 ? _this$storage : {};
    }
  }, {
    key: "writeStorage",
    value: function writeStorage() {}
  }], [{
    key: "isAvailable",
    get: function get() {
      return true;
    }
  }]);
  return MemoryStorage;
}(Storage);
var TEST_KEY = "__SESSIONSTORAGE_TEST_KEY__";
var TEST_VALUE = "__SESSIONSTORAGE_TEST_VALUE__";
var SessionStorage = /*#__PURE__*/function (_Storage4) {
  _inherits(SessionStorage, _Storage4);
  var _super4 = _createSuper(SessionStorage);
  function SessionStorage() {
    _classCallCheck(this, SessionStorage);
    return _super4.apply(this, arguments);
  }
  _createClass(SessionStorage, [{
    key: "clearStorage",
    value: function clearStorage() {
      sessionStorage.removeItem(this.storageKey);
    }
  }, {
    key: "readStorage",
    value: function readStorage() {
      return deserialize(sessionStorage.getItem(this.storageKey));
    }
  }, {
    key: "writeStorage",
    value: function writeStorage() {
      sessionStorage.setItem(this.storageKey, serialize(this.storage));
    }
  }], [{
    key: "isAvailable",
    get: function get() {
      try {
        if (_typeof(window.sessionStorage) === "object") {
          window.sessionStorage.setItem(TEST_KEY, TEST_VALUE);
          if (window.sessionStorage.getItem(TEST_KEY) === TEST_VALUE) {
            window.sessionStorage.removeItem(TEST_KEY);
            return true;
          }
        }
      } catch (_unused3) {}
      return false;
    }
  }]);
  return SessionStorage;
}(Storage);
exports.CookieStorage = CookieStorage;
exports.LocalStorage = LocalStorage;
exports.MemoryStorage = MemoryStorage;
exports.SessionStorage = SessionStorage;
exports.Storage = Storage;
exports.deserialize = deserialize;
exports.serialize = serialize;
//# sourceMappingURL=index.js.map
